org &2000

ld a,0
call &bc0e

ld b,12
ld hl,filename1
ld de,&1000
call &bc77
ld hl,ldfonts
call &bc83
call &bc7a

ld de,font16pal
call changepal
call disableints

ld hl,5632
ld ix,ldfonts
ld de,&4000

font16byte:
ld c,(ix):inc ix

xor a
bit 1,c:jr z,lnobit3:add 8:lnobit3:
bit 5,c:jr z,lnobit2:add 4:lnobit2:
bit 3,c:jr z,lnobit1:add 2:lnobit1:
bit 7,c:jr z,lnobit0:add 1:lnobit0:
ld (de),a:inc de

xor a
bit 0,c:jr z,rnobit3:add 8:rnobit3:
bit 4,c:jr z,rnobit2:add 4:rnobit2:
bit 2,c:jr z,rnobit1:add 2:rnobit1:
bit 6,c:jr z,rnobit0:add 1:rnobit0:
ld (de),a:inc de

dec hl
ld a,h:or l
jr nz,font16byte


asd
jr asd
ret


filename1:
db "16mkfont.bin"

font16pal:
db 0,3,6,15
db 1,2,5,14
db 12,18,21,22
db 4,7,8,17

; Pallete changing subroutine
; ---------------------------
; DE = Paltable

changepal:

ld bc,&7f00

palloop:

push de:push bc
out (c),c
ld a,(de):ld d,0:ld e,a
ld hl,palcodes:add hl,de
ld c,(hl):out (c),c
pop bc:pop de
inc bc:inc de

ld a,c
cp 16
jr nz,palloop

ret


;Hardware colour pallete precs
; ---------------------------

palcodes:
db &54,&44,&55,&5c,&58,&5d,&4c,&45,&4d,&56,&46,&57,&5e,&40,&5f,&4e,&47,&4f,&52,&42,&53,&5a,&59,&5b,&4a,&43,&4b

disableints:
di:LD HL,&C3FB:LD(&38),HL
ret

ldfonts:
