org &2000

ld a,0
call &bc0e

ld b,12
ld hl,filename1
ld de,&1000
;call &bc77
ld hl,ldfonts
;call &bc83
;call &bc7a

ld de,font16pal
call changepal
call disableints


ld bc,rotexts
db &DD,%00100110,0	;ld XH,0	;incs before 1st white
db &DD,%00101110,0	;ld XL,0	;0=no white yet, 1=after white
ex af,af':xor a:ex af,af'
ld hl,&4200
ld de,&4000
ld a,l:ld (de),a:inc e:ld a,h:ld (de),a:inc e	; writting first code address on the list

ntimes32:
ld a,32

ytimes16:
ld a,16

ld (hl),%11100001 ;pop hl:inc hl
ld (hl),%00011001 ;add hl,de:inc hl

xtimes2:
ld a,2
ld a,(bc):inc bc
push af

btimes4:
exx
ld e,4

pop af
ld de,0
srl a:jr nc,nullbit1:ld d,1:nullbit1:
srl a:jr nc,nullbit2:ld e,2:nullbit2:
push af
xor a:add d:add e
exx
jr z,nowhite

push af

db &DD,%01111100 ;ld a,XH
or a
jr z,nomorestart
ld (hl),%01111101 ;ld a,l:inc hl
ld (hl),%11000110:inc hl:db &DD,%01111100 ;ld a,XH:ld (hl),a ;add a,n(XH):inc hl
db &DD,%00100110,0	;ld XH,0
db &DD,%00101110,1	;ld XL,1	; it passed white now
nomorestart:

pop af

cp 3
jr nz,no3
ld (hl),&36:inc hl:ld a,255:ld (hl),a ;ld (hl),255:inc hl
ld (hl),%00101100 ; inc l:inc hl
jr no1
no3:

cp 2
jr nz,no2
ld (hl),%00111110:inc hl:ld (hl),%10101010 ;ld a,%10101010:inc hl
ld (hl),%10110110 ;or (hl):inc hl
ld (hl),%01110111 ;ld (hl),a:inc hl
ld (hl),%00101100 ;inc l:inc hl
jr no1
no2:

ld (hl),%00111110:inc hl:ld (hl),%01010101 ;ld a,%01010101:inc hl
ld (hl),%10110110 ;or (hl):inc hl
ld (hl),%01110111 ;ld (hl),a:inc hl
ld (hl),%00101100 ;inc l:inc hl
no1:


ld a,(btimes4+2):dec a:ld (btimes4+2),a
or a
jr nz,btimes4
ld a,4:ld (btimes4+2),a

pop af
ld a,(xtimes2+1):dec a:ld (xtimes2+1),a
or a
jp nz,xtimes2
ld a,2:ld (xtimes2+1),a

jr nextbline


nowhite:
db &DD,%01111101 ;ld a,XL
dec a
jr z,nextbline
db &DD,%00100100	;inc XH

ld a,(btimes4+2):dec a:ld (btimes4+2),a
or a
jp nz,btimes4
ld a,4:ld (btimes4+2),a

pop af
ld a,(xtimes2+1):dec a:ld (xtimes2+1),a
or a
jp nz,xtimes2
ld a,2:ld (xtimes2+1),a


nextbline:
db &DD,%00100110,0	;ld XH,0	;incs before 1st white
db &DD,%00101110,0	;ld XL,0	;0=no white yet, 1=after white

ld a,(ytimes16+1):dec a:ld (ytimes16+1),a
or a
jp nz,ytimes16
ld a,16:ld (ytimes16+1),a

ld (hl),&C9 ;ret:inc hl
ld a,l:ld (de),a:inc e:ld a,h:ld (de),a:inc e	; writting next code address on the list

ld a,(ntimes32+1):dec a:ld (ntimes32+1),a
or a
jp nz,ntimes32

asd
jr asd
ret


filename1:
db "16mkfont.bin"

font16pal:
db 0,3,6,15
db 1,2,5,14
db 12,18,21,22
db 4,7,8,17

; Pallete changing subroutine
; ---------------------------
; DE = Paltable

changepal:

ld bc,&7f00

palloop:

push de:push bc
out (c),c
ld a,(de):ld d,0:ld e,a
ld hl,palcodes:add hl,de
ld c,(hl):out (c),c
pop bc:pop de
inc bc:inc de

ld a,c
cp 16
jr nz,palloop

ret


;Hardware colour pallete precs
; ---------------------------

palcodes:
db &54,&44,&55,&5c,&58,&5d,&4c,&45,&4d,&56,&46,&57,&5e,&40,&5f,&4e,&47,&4f,&52,&42,&53,&5a,&59,&5b,&4a,&43,&4b

disableints:
di:LD HL,&C3FB:LD(&38),HL
ret


rotexts:

db 0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,3,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,1,0,7,0,12,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,1,0,3,0,6,0,8,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,3,0,6,0,4,0,8,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,12,0,8,0,24,0,16,0,32,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,16,0,48,0,32,0,32,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,96,0,64,0,64,0,64,0,64,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,128,0,128,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 3,0,1,0,1,0,0,128,0,128,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 12,0,6,0,2,0,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 48,0,24,0,12,0,4,0,2,0,1,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 192,0,224,0,48,0,24,0,4,0,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,192,0,224,0,56,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,192,0,240,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,240,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,56,0,224,0,192,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,2,0,4,0,24,0,48,0,224,0,192,0,128,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,2,0,4,0,8,0,24,0,48,0,96,0,224,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,6,0,4,0,12,0,24,0,24,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,2,0,2,0,6,0,6,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,1,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,128,0,128,0,128,0,128,0,192,0,192
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,64,0,64,0,96,0,32,0,32
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,64,0,32,0,48,0,16,0,24,0,28
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,16,0,8,0,12,0,6,0,3
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,8,0,6,0,3,0,1,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,12,0,7,0,1,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,14,0,3,0,0,0,0,0,0,0,0,0,0
db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,63,0,1,0,0,0,0,0,0,0,0,0,0,0,0

ldfonts:
